//----------------------------------------------------------------------\
// Daniel Hovis                   Program Name: linedrw.cpp             |
// C Program                              Date: 5/27/92                 |
//                                                                      |
//                                                                      |
//      This is a simple program called linedraw  (like etch a scketch) |
//              it will allow the user to draw lines by pressing the    |
//               arrow keys and change colors by numbers....            |
//----------------------------------------------------------------------/
#include <stdio.h>		           // Include Statements.
#include <conio.h>
#include <graphics.h>
#include <dos.h>
#include <stdlib.h>
								   // Define statements.
//#define GETA if(a=getch()==0) a=getch(); else
#define ESC 0x1b                   // Define the escape key.
#define CLIP_ON   0                // Clipping in viewport.

void MainWindow();                 // The graphics initialization.
void UserInst();                   // User instructions.
void Pause();                      // This gets a key input for
LineDraw(int a);                   // Drawline process.

 int MaxY=getmaxy();
 int MaxX=getmaxx();
 int MidX=MaxX/2;
 int MidY=MaxY/2;
 int Xpos=MidX;
 int Ypos=MidY;
 int a;


void main()
 {
  MainWindow();
  UserInst();
  Pause();
  LineDraw(a);



}
void MainWindow()
{
int gdriver = DETECT, gmode, errorcode;

									// Initialize graphics
									// and local variables.
initgraph(&gdriver, &gmode, "");

									// Result of initialization.
   errorcode = graphresult();
   if (errorcode != grOk)           // Oops graphic's error.
   {                                // Is egavga.bgi in output dir?
	  printf("Graphics error: %s\n", grapherrormsg(errorcode));
	  printf("Press any key to halt:");
	  getch();
	  exit(1);                      // Terminate with an error code.
   }

  setcolor(getmaxcolor());
  cleardevice();		        	// Clear graphics screen.
  setcolor(RED);
  settextstyle(TRIPLEX_FONT, HORIZ_DIR,4);
  outtextxy(423,427, "LINE DRAW" );	// Dislpay the title.
  setcolor(CYAN);
  outtextxy(422,428, "LINE DRAW" );	// Red shadow.

}

//------------------------- instructions -----------------------

void UserInst()
{

printf("Arrow keys draw, Numbers change color, * is Black, ESC to Quit");

setcolor(WHITE);
outtextxy(2,85,"0");
setcolor(BLUE);
outtextxy(2,115,"1");
setcolor(GREEN);
outtextxy(2,145,"2");
setcolor(CYAN);
outtextxy(2,175,"3");
setcolor(RED);
outtextxy(2,205,"4");
setcolor(MAGENTA);
outtextxy(2,235,"5");
setcolor(BROWN);
outtextxy(2,265,"6");
setcolor(LIGHTGRAY);
outtextxy(2,295,"7");
setcolor(YELLOW);
outtextxy(2,325,"8");
setcolor(LIGHTBLUE);
outtextxy(2,355,"9");
setcolor(WHITE);
outtextxy(2,385,"*");
outtextxy(1,1,".");           // try to make this start at center!


}

//---------------------- Pause ---------------------------------

//	PAUSE: Pause until the user enters a keystroke. If the
//	key is an ESC, then exit program, else simply return.

void Pause()
{
  int a;


  fflush(stdin);

  a=getch();			        	// Read a character from kbd.

  fflush(stdin);

  if( ESC == a ){			        // Does user wish to leave?
	closegraph();			        // Change to text mode.
	exit(1);	}			        // Exit.

  LineDraw(a);

}

//---------------------- Line Draw ---------------------------------

 LineDraw(int a)
{

  if(a==72)                         // Go up line go up!
   Ypos--;

  if(a==77)                         // Line right.
   Xpos++;

  if(a==80)                         // Line down.
   Ypos++;

  if(a==75)                         // Line left.
   Xpos--;



 /* if(a==152)                      // Line Diagnols...
   Ypos-=1;
   Xpos+=1;

  if(a==155)                        //not working yet
   Ypos-=1;
   Xpos-=1;

  if(a==160)
   Ypos+=1;
   Xpos+=1;

  if(a==157)
   Ypos+=1;
   Xpos+=1;   */

  if(a==48)                         // Change colors...
   setcolor(WHITE);

  if(a==49)
   setcolor(BLUE);

  if(a==50)
   setcolor(GREEN);

  if(a==51)
   setcolor(CYAN);

  if(a==52)
   setcolor(RED);

  if(a==53)
   setcolor(MAGENTA);

  if(a==54)
   setcolor(BROWN);

  if(a==55)
   setcolor(LIGHTGRAY);

  if(a==56)
   setcolor(YELLOW);

  if(a==57)
   setcolor(LIGHTBLUE);

  if(a==42)
   setcolor(BLACK);
  outtextxy(Xpos,Ypos,".");
  //lineto(Xpos,Ypos);
  fflush(stdin);
  Pause();

return(0);
}
